/*
 * Bot chat messages.
 *
 * There are several categories of messages:
 *   1. Entry
 *   2. End of level - Top place
 *   3. End of level - Middle place
 *   4. End of level - Bottom place
 *   5. Fragging someone
 *   6. Commiting suicide
 *   7. Getting fragged by BFG
 *
 * The strings may contain certain special sequences that will be replaced
 * by the appropriate player name. The special sequences are:
 *
 *    %b -> bottom player (applicable to cases 1-4 above)
 *    %t -> top player (applicable to cases 1-4 above)
 *    %s -> self name  (applicable to all cases above)
 *    %o -> other player (frag victim for case 5, killer for case 7)
 */

/////////////////////////////////////////////////////////////////////////////

static const char *bc_entry_msg_list[] =
{
	"It's pay-back time!",
	"Run for cover %t! I'm back!",
	"Hi there",
	"Hello",
	"I bet you missed me",
	"G'day",
	"Yo! %s is in the house!",
	"Wassup",
	"Hey",
	"Hi",
	"Run in fear, %s is here!",
	"Let's get it on!",
	"Crap. Losers in here again!",
	"Yessss! Fresh victims!",
	"I'm back!",
	"Showtime!",
	"Let's rock and roll",
	"Let's rock",
	"Great! Easy frags ahead.",
	"It's party time!",
	"Let's kick it",
	"Let's get rollin'",
	"Time for some fireworks",
	"Today, I am death incarnate! Fear the name of %s",
	"Yo, %t I've got a rocket with your name on it!",
	"%s is here. There will be no survivors!",
	"Yo! I'm back in da House!",
	"WOW! Is the circus in town or something?",
	"So, %t we meet again",
	"Where have you been hiding little rabbit?",
	"Let the Tears begin!",
	"Guess its time to mow the grass",
	"I am so ready for this",
	"It's time for 'Bowling for Morons'",
	"Fresh meat!",
	"Howdy!",
	"Let's get it ON!",
	"Let's do it!",
	"No Prisoners!",
	"It's time for %s to lay down the law here.",
	"You got an early retirement coming up, %t",
	"Hey, little kitty-cat, I have a treat for you.",
	"Time to settle some scores!",
	"Make this a good day, cuz it'll be your last.",
	"%t, I'm gonna kick your sorry butt into the next county.",
	"Hi, I'm %s, and I am a fragaholic.",
	"%t, I got a warrant for your destruction",
	"Hola",
	"Privet",
	"Hiya",
	"Let me guess. We're not in Kansas... again.",
	"Battle stations!",
	"Look how they line up like lambs to the slaughter.",
	"Salut",
	"Guten Tag",
	"Buenos Dias",
	"Aloha",
	"Konnichiwa",
	"Let's get this over with",
	"Today's lesson will be pain",
	"Who needs a lesson today?",
	NULL
};

/////////////////////////////////////////////////////////////////////////////

static const char *bc_end_top_msg_list[] =
{
	"Groovy",
	"My house!",
	"Don't mess with the best!",
	"Yesssssss!!!",
	"Holey Moley!",
	"Wow",
	"Game Over! Insert Coin",
	":-D",
	"heh",
	"Bring 'em on, I'm hot today!!",
	"I'm new and improved. Can't you tell?",
	":-)",
	";-)",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"Oh, Yesssssss!",
	"You're slowing down %b. That was far too easy.",
	"%b maybe you ought to take up chess.",
	"You do a great 'roadkill' impression, %b",
	"My how the mighty have fallen. And fallen. And fallen.",
	"A million customers served ;-)",
	"Are you normally this bad, %b?",
	"Cooperate and we'll all be done much sooner.",
	"Maybe you're just in the wrong line of business.",
	"Your head and body are gonna need separate maintainance",
	"The apocalypse is at hand",
	"p0wned",
	"lol",
	"Yabadabadooo!!",
	"Your mother died of sadness from seeing you %b; did she not?",
	"Just stand still and I'll make it quick",
	"l33t",
	"ph33r",
	"Muahahaha",
	"You accept defeat far too well, %b",
	"All in a day's work",
	"So I'm a camper. Sue me.",
	"Get your sorry ass off my turf!",
	NULL
};

/////////////////////////////////////////////////////////////////////////////

static const char *bc_end_middle_msg_list[] =
{
	":)",
	"good match",
	"That was definitely fun ... let's do it again sometime",
	"hehehe",
	"Challenging",
	"Nice!",
	"Way to go %t. That definitely hurt.",
	":-(",
	":)",
	"Nice one, %t",
	"How you'd do that %t?",
	"Impressive!",
	"Excellent!!",
	"That rocked %t!",
	"I never saw that one coming %t",
	"Smooo-oooth",
	"Nice shootin' %t!",
	"Some mighty fine shooting there, %t",
	"Bellisimo, baby!",
	"This will not go unavenged",
	"Good match ... better if I win.",
	"Definitely fun ... let's do it again sometime.",
	"You just try that again, %t",
	"Accidents happen",
	"Be afraid, %t. Be very afraid.",
	"I'm learning your tricks, %t.",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"Bunch of losers",
	"Ay de mi'! It smells like purgatory. Huele malo.",
	"%t cheats and %b sucks. Now that we know, let's go again.",
	"%t on top? Send me back to boot camp.",
	"So soon? just getting warmed up.",
	"You call that a good match? Sloppy. Very sloppy.",
	"Your techniques warrant future study, %t",
	NULL
};

/////////////////////////////////////////////////////////////////////////////

static const char *bc_end_bottom_msg_list[] =
{
	"Heh ... I had the safety on ...",
	"I'm taking off the kid gloves now, %t!",
	"Okay, now I start fighting for real!",
	"Enjoy that one. Your luck is about to run out, %t.",
	"Now the match gets serious.",
	"%t you're a stinking camper!",
	"camper!!!!!",
	"I see laming is back in fashion",
	"I'm definitely out of my league here",
	"Figures, Mr. Camper on top",
	"That was the biggest waste of time ever",
	"This was tragic",
	"It saddens me to see tactics brought to such a low estate",
	"I will accept this as yet another learning experience",
	":-(",
	"That was lame and you know it, %t",
	"This was truly tragic",
	"What a world ... what a world",
	"I vote %t as happy camper of the day!",
	"You're allowed one lucky shot a day, %t",
	"I'm not impressed, %t",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"gg",
	"grrrr",
	"grrrr",
	"Bullshit fighta",
	"Stoopid game",
	"Caramba! When did hell freeze over?",
	"Madre de Dios!",
	"I bet you don't get invited to many parties, %t",
	"Ouch. That hurt",	
	"ouch",	
	"ouch",	
	"The pain... the pain",
	"I suck",
	"Chaos theory in action, %t",
	"Screw this",
	"Waste of time.",
	"Next time your butt is mine, %t",
	"You not happy, %t. You soon dead.",
	"Luck. Pure luck.",
	"Next time you die!",
	"I do not know which is worse, eternal damnation or losing to %t",
	"There will be some serious payback for this",
	"You got camping down to a science, don't you, %t?",
	"You shouldn't be proud %t! That was lame!",
	NULL
};

/////////////////////////////////////////////////////////////////////////////

static const char *bc_frag_msg_list[] =
{
	"Nice catch, %o!",
	"Somebody stop me!",
	"Watch yer back next time %o",
	"Sorry, %o; this is a NO BREATHING zone.",
	"Burn baby, burn",
	"He's dead, Jim!",
	"Someone get a mop",
	"What we have here, is a failure to communicate",
	"Do you to practice to be that bad, %o?",
	"There oughtta be a law against me",
	"Get down and stay down!",
	"Mess with the best, %o; die like the rest!",
	"You fought the law and the law won",
	"Clean up your mess before you go %o",
	"Whack 'em and Stack 'em!",
	"Somebody wanna clean this mess up?",
	"Let's see ... you were 'on the phone', right?",
	"lol",
	"My mama taught me that move ... just before I fragged her.",
	"That was quick",
	"Asi' se hace!",
	"You liked that, si?",
	"It's never too late for a change of career, %o",
	"Is that your face, %o, or are you mooning me?",
	"Are you some kind of pacifist, %o?",
	"I don't like to speak ill of the dead, but you suck.",
	"I can take away your pain",
	"You better see a doctor about that",
	"Is this a bad time for you?",
	"Pain clears the mind",
	"Why do you run away? Won't you be my friend?",
	"Anyone else smell smoke?",
	"frag bait",
	"Fight, or get the heck outta Dodge",
	"Muahahaha",
	"Terminated",
	"Can't you at least make this interesting, %o?",
	"That was beautiful, like art",
	"Say good night, %o",
	"%o, you are hardly even target practice today",
	"%o, is that a mask or are you just naturally ugly?",
	"Who wants to be a hero?",
	"Premature Termination AGAIN?",
	"%o, you have the right to remain dead",
	"Isn't it past your bedtime %o?",
	"Don't bleed so much, %o. Makes the floor slippery.",
	"D00000d, I almost feel bad!",
	"Are you, like, pretending to be a statue, %o? Good disguise!",
	"Who wrote your program, %o? Like, Benjamin Franklin?",
	"%o d00d, were you like, sad, when the dinosaurs died?",
	"I told you to duck",
	"You blow up real pretty, %o",
	"Nice splatter there, %o. Good color choice.",
	"Who's yer daddy?",
	"You got any more internal organs you'd like to share with us, %o?",
	"Honestly, %o, you look much better dead.",
	"I found your face, %o. You want it back?",
	"Your stink betrays your position, %o",
	"Did I ruin your day, %o?",
	"I'm like a kid in a candy store!",
	"If looks could kill, %o, your face would be a serial killer",
	"**Sniff** ... **sniff**. Did you soil yourself, %o?",
	"You must practice more, %o. That death was very unprofessional.",
	"Whole lot more where that came from",
	"%o, you are making this far too easy",
	"You're not naturally bad, %o. What you got takes practice.",
	"What?  You waitin' for your nails to dry, %o?",
	"You are a challenging target, %o",
	"%o, you stink too much to even think of hiding.",
	"Come an' get it!",
	"It is time for your first lesson: humility.",
	"Kill yourself, %o and save me the trouble.",
	"Pick up your toys and go home kid",
	NULL
};

/////////////////////////////////////////////////////////////////////////////

static const char *bc_suicide_msg_list[] = 
{
	"I meant to do that",
	"What a world ... what a world",
	"Ow",
	":-(",
	"I'm really tired",
	"I hate life",
	":(",
	"Oops",
	"Just testing",
	"Ouch",
	"I hate that. I just hate it.",
	"Doh",
	"I did that on purpose",
 	"Crap!",
	"Grrrrrr",
	"Just a minor setback",
 	"I hate it when that happens",
	"Stop laughing",
	"Arrrrg. Can't believe that happened.",
	"I can't believe I did that",
	"I don't plan on repeating this",
	"Heh",
	"I'm dead Jim!",
	"Oughta be more careful",
	"I'm getting too old for this shit",
	"This sucks",
	"wtf",
	"lol",
	"shit",
	"A slight miscalculation",
	"Accidents happen",
	"Shit happens",
	"There are worse ways to die...",
	"That's not right",
	NULL
};

/////////////////////////////////////////////////////////////////////////////

static const char *bc_bfg_death_msg_list[] = 
{
	"Bullshit fighta",
	"Bullshit fighta",
	"Bullshit fighta",
	"Bullshit fighta",
	"Bullshit fighta",
	"Nou BFG",
	"Nou BFG",
	"Nou BFG",
	"Nou BFG",
	"Nou BFG",
	"BFG-whore",
	"Use a skill weapon next time",
	"You want fireworks? I'll give you friggin' fireworks!",
	"Loser!",
	"No-skill puke!",
	"BFG-camper!!!",
	"bfg noob",
	"lamer",
	"loozR",
	"bottom feeder",
	"coward",
	"scumbag",
	"lowlife",
	"That was lame and you know it, %o",
	"Enjoy that one. Your luck is about to run out, %o",
	"You're sick. Leave me alone.",
	"camper",
	"camping punk",
	"dirtbag",
	"frag farmer",
	"spawn camper",
	"How charming",
	"I bet you're darn proud of yourself now, %o",
	"Whoa, d00d, that was, like, totally hostile!",
	"That was major unfriendly-like, d00d.",
	"I'd tell you to kiss my ass, but I'm afraid you'd take me up on it.",
	"BFG-Wimp!",
	"Bozo!",
	"So this is the light at the end of the tunnel everyone talks about.",
	"Fragbait, you are about to experience a personal tragedy.",
	"You shoulda saved that for later, %o. Cause now your in deep shit.",
	"I got nothing good to say to you, %o",
	"This your first day with that weapon?",
	"Oh, so you want to play rough?",
	"No-skill llama!",
	NULL
};

/////////////////////////////////////////////////////////////////////////////
